/***************************************************************************
*                          aclCheck.cpp  -  description
*                             -------------------
*    begin                : Sam Feb  1 17:08:52 CET 2003
*    copyright            : (C) 2003 by the gomd group at savannah.org/
*    email                : rpons@rinu.org, brian@axehind.com, jp80@libero.it, mosixview@t-online.de
****************************************************************************/

/**
 * NOTES:
 * Last update by rejected
 *
 * Contains code to handle Access Control Lists check
 */

#include "aclRulebook.h"

/**
 * constructor for class aclRulebook
 * @param localIP contains the IP of local node
 */
aclRulebook::aclRulebook(string localIP)
{
	m_localIP = localIP;
}

/**
 * reads the file with the ACL rules and fills the ACL map
 * @param aclFile is the path to file file with the ACL rules.
 */
void aclRulebook::fillAclMap(string aclFile)
{
	cout << "[ACL]: loading ACL rulebook from file..." << endl;
	cout << "[ACL]: opening file: \"" << aclFile << "\""  << endl;
	m_aclMap = new multimap<string,string>(m_util.parseSpecialFile(aclFile,":"));
	if (m_aclMap->size()==0)
	{
		cout  << "[ACL]: acl rulebook file is empty!"  << endl;
		cout  << "[ACL]: setting restrictive control (\"deny all\")." << endl;
		m_aclMap->insert(make_pair(string("ANY_IP"),string("ACL_DENY_CONTROL")));
	}
	cout << "[ACL]: rules map succesfully filled." << endl;
}

/**
 * returns the ACL rules map
 * @return the map with the ACL rules
 */
multimap<string,string>	aclRulebook::getAclMap()
{
	return *m_aclMap;
}

/**
 * prints the contents of the ACL rules map
 */
void aclRulebook::printAclMap()
{
	m_util.printMultiMap(*m_aclMap , "[ACL]: contents of rules map...", "       -> ");
}
