#ifndef __GOMD_CHPOX_SUPPORT_H
	#define __GOMD_CHPOX_SUPPORT_H

	#include <cc++/thread.h>
	#include "chpoxProc.h"
	#include "constants.h"
	#include "utils.h"
	#include <map>
	#include <list>
	#include <string>
	#include <cctype>
	#include <dirent.h>

	typedef int chpox_autodump_t;

	using namespace std;
	using namespace ost;

	class chpoxSupport: public Thread
	{
		//vars
		public:
		bool 			m_isActive;
		utils			m_util;
		list<chpoxProc>		m_registeredProcs;
		list<pid_t>		m_pendingDumpsQueue;
		list<pid_t>		m_listOfMigratedProcs;
		map<string, string>	m_chpSupportConfiguration;
		map<string, string> 	m_foundDumps;

		//functions
		public:
		chpoxSupport();
		bool			isEnabled();
		list<string>		getLibsList(string filePath);
		bool			registerAndDumpProcess(pid_t pid);
		bool			restoreProcess();
		void			updateList(pid_t pid, string exe, list<string> requiredLibs, string dumpFile);
		void			printRegisteredProcList();
		void			dumpRegisteredProcess(pid_t pid);
		bool			appendToPendingDumpsQueue(pid_t newPid);
		void			getListOfMigratedProcs();
		void			fillChpSupportConfiguration(string chpFile);
		void			printChpSupportConfiguration();
		string			getListOfAvailableDumps();
		string			restoreProcess(pid_t pidOfProcToBeRestored, unsigned int numOfDumpFileToBeUsed, bool killProcessIfStillRunning=false);
		void			run();
		chpox_autodump_t 	stringToAutodumpType(string toBeConverted);
		bool			isDumpCorrupted(string dumpFilepath);
	};

#endif //end of __GOMD_CHPOX_SUPPORT_H
