/***************************************************************************
                          constants.h  -  description
                             -------------------
    begin                : Sam Feb  1 17:08:52 CET 2003
    copyright            : (C) 2003 by the gomd group at savannah.org/
    email                : rpons@rinu.org, brian@axehind.com, jp80@libero.it, mosixview@t-online.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/* $Id: constants.h,v 1.31 2004/03/29 21:19:34 rejected Exp $ */

/**
 * NOTES:
 * Created by rejected
 *
 * Contains several constants used in the whole gomd project
 */

#ifndef __GOMD_STD_CONSTANTS_H
	#define __GOMD_STD_CONSTANTS_H

	#define GOMD_DEBUG_MODE		1 //1=enabled; 0=disabled

	//files and directory used (read or written) by gomd
	#define HPC_CLUSTER_DIRECTORY  	"/proc/hpc"
	#define HPC_NODES_DIRECTORY    	"/proc/hpc/nodes"
	#define CS_HTML_REPORT_FILE  	"/etc/gomd/cs_snapshot.html"
	#define GOMD_PIDFILE           	"/var/run/gomd"
	#define KNOWN_GOMDS_FILE  	"/etc/gomd/knownGomds.conf"
	#define OM_NODESMAP_FILE	"/etc/openmosix.map"

	//gomd configuration files
	#define ACL_CONF_FILE     	"/etc/gomd/acl.conf"
	#define CHPSUPPORT_CONF_FILE    "/etc/gomd/chpsupport.conf"
	#define GOMD_CONF_FILE     	"/etc/gomd/gomd.conf"
	#define LOADLIMIT_CONF_FILE     "/etc/gomd/llsupport.conf"
	#define SCX_CONF_FILE     	"/etc/gomd/scx.conf"

	//misc constants
	#define GOMD_VERSION 0.1
	#define GOMD_EXIT_SUCCESS 0
	#define GOMD_EXIT_FAILURE -1
	#define ALL 0
	#define IGNORE_NODE 1
	#define ANALYZER_UNVALID_OPTION -1

	//gomd settings
	#define CLIENT_TIMEOUT 60000
	#define CONN_HANDLER_MAX_REQUEST_LENGTH 254
	#define COMMAND_HISTORY_SIZE 10
	#define GOMD_SEARCHER_IP_TO_PING 10
	#define MAX_REMOTE_NODES_TO_HANDLE 256
	#define MAX_CHARS_TO_READ 256
	#define SCX_MAX_ARGUMENTS_NUMBER 5
	#define SCX_MAX_OUTPUT_LINE_FOR_PROCESS 5
	#define SCX_MAX_CHARS_READ_FROM_FILE 1024
	#define INFINITE_TIME -1
	//#define PROCESS_TIME_TO_LIVE 30
	#define PROCESS_TIME_TO_LIVE INFINITE_TIME
	
	

	//error codes for utils class
	#define UTILS_IO_ERROR   "-10"
	#define UTILS_CONV_ERROR "-11"
	#define UTILS_NET_ERROR  "-12"

	//error codes for omInfo class
	#define OMINFO_OM_NOT_STARTED_OR_NODE_NOT_CONFIGURED "-20"

	//error codes for gomdSearcher (RGS) class
	#define RGS_CANNOT_RESOLVE_IP "-30"

	//ACL constants
	#define ACL_FULL_CONTROL		2
	#define ACL_LOCAL_INFOS_ONLY		1
	#define ACL_DENY_CONTROL		0
	#define ACL_THREAD_ERROR_OCCURRED      -1

	//connHandler placeholders (used in analyzeRequest() function)
	#define NA                          "NA"
	#define NODELIST             "NODELIST"
	#define NUMBER               "NUMBER"
	#define REMOTE_OR_LOCAL_NODE "REMOTE_OR_LOCAL_NODE"
	#define STRING                 "STRING"

	//chpox support
	#define CHPOX_DUMP_DIR "/tmp"
	#define CHPOX_DUMP_SIGNAL 31
	#define CHPOX_INFO_FILE "/proc/chpox/info"
	#define CHPOX_MAX_DUMPS_PER_PROCESS 5
	#define CHPOX_REGISTER_MECHANISM "9"
	#define CHPOX_REFRESH_TIME	10
	#define CHPOX_DUMP_ONCE 0
	#define CHPOX_DUMP_PERSISTENT 1
	#define CHPOX_ALL_APPS 10
	
	//loadlimit support
	#define LOADLIMIT_HPC_FILE "/proc/hpc/admin/loadlimit"

	//escape sequences for color shell output
	#define BLUE	"\033[36m"
	#define RED	"\033[31m"
	#define GRAY	"\033[37m"
	#define GREEN	"\033[32m"
	#define NORMAL	"\033[0m"

	//security settings
	#define SEC_FAKE_DIR "/tmp/fake"

	//xmlLog support
	#define XML_LOG_FILE     "/etc/gomd/scx.conf"

#endif //end of __GOMD_STD_CONSTANTS_H
