/***************************************************************************
*                          globalInitializer.h  -  description
*                             -------------------
*    begin                : Sam Feb  1 17:08:52 CET 2003
*    copyright            : (C) 2003 by the gomd group at savannah.org/
*    email                : rpons@rinu.org, brian@axehind.com, jp80@libero.it, mosixview@t-online.de
****************************************************************************/

/**
 * NOTES:
 * Created by rejected
 *
 * Contains code to get system infos
 */

#ifndef __GOMD_CS_COLLECTOR_H
        #define __GOMD_CS_COLLECTOR_H
	#include <cc++/thread.h>
	#include <map>
	#include <string>
	#include "aclRulebook.h"
	#include "aclCheck.h"
	#include "chSupport.h"
	#include "chpoxSupport.h"
	#include "clusterSnapshot.h"
        #include "constants.h"
	#include "gomd2gomd.h"
	#include "gomdSearcher.h"
	#include "llSupport.h"
	#include "lmsSupport.h"
	#include "scxCheck.h"
	#include "scxCmdsbook.h"
	#include "security.h"
        #include "utils.h"
	#include "omInfo.h"
	#ifdef __LIBGTOP
	#include "sysInfo.h"
	#endif
	
        using namespace std;
	using namespace ost;

	//this class implement the SINGLETON design pattern
        class globalInitializer: public Thread
        {

		//vars
		private:
		static	globalInitializer*	m_instance;

		//vars
		public:
		bool			m_omEnabled;
		bool			m_lmsSupportEnabled;
		bool			m_doContinue;
		aclCheck*		m_aclCheck;
		aclRulebook*		m_aclRulebook;
		chpoxSupport*		m_chpoxSupport;
		chSupport*		m_chSupport;
		clusterSnapshot		m_cs;
		gomd2gomd		m_g2g;
		gomdSearcher* 		m_gs;
		llSupport*		m_llSupport;
		lmsSupport*		m_lmsSupport;
		multimap<string,string> m_knownGomds;
		scxCheck*		m_scxCheck;
		scxCmdsbook*		m_scxCmdsbook;
		security		m_security;
		string			m_localIP;
		string 			m_localHostname;
		string			m_localNodeID;
		unsigned int		m_refreshInterval;
		#ifdef __LIBGTOP
		sysInfo 		m_sysInfo; //used to get system (extra) infos
		#endif
		omInfo 			m_omInfo; //gets oM data
		utils			m_util;

		//functions
                public:
		static	 globalInitializer*	Instance(string localIP, string localHostname); //singleton pattern instance creation handler
		void	enableLivecdSpecificSettings();
		void	readOpenMosixMapFile();
		void	testRegisterProcess();

		//functions
                protected:		
			globalInitializer(string localIP, string localHostname);
		void	run();
		void	setRefreshInterval(unsigned int newRefreshInterval);
			~globalInitializer();
        };
#endif // end of __GOMD_CS_COLLECTOR_H
