/***************************************************************************
                          gomdSearcher.h  -  description
                             -------------------
    begin                : Sam Feb  1 17:08:52 CET 2003
    copyright            : (C) 2003 by the gomd group at savannah.org/
    email                : rpons@rinu.org, brian@axehind.com, jp80@libero.it, mosixview@t-online.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/* $Id: gomdSearcher.h,v 1.14 2004/04/11 20:59:01 rejected Exp $ */

/**
 * NOTES:
 * Created by rejected
 *
 * This class contains the code for gomd2gomd communication.
 */
#ifndef __GOMD_GS_H
	#define __GOMD_GS_H
	#include <cc++/socket.h>
	#include <cc++/thread.h>
	#include <cc++/misc.h>
	#include <iostream>
	#include <cstdlib>
	#include <string>
	#include <map>
	#include "constants.h"
	#include "gomd2gomd.h"
	#include "omInfo.h"
	#include "utils.h"

	using namespace std;
	using namespace ost;

	class gomdSearcher: public Thread
	{
		//vars
		public:
		string             m_localIP;
		gomd2gomd          m_g2g;
		omInfo*            m_omInfo;
		utils              m_util;

		map<string,string> m_knownGomds;
		bool               m_searchByOmDiscd;
		bool               m_searchInProgress;
		bool               m_pendingSearch;
		bool		   m_doContinue;
		unsigned int       m_highestRangeIP;

		//functions
		public:
		       gomdSearcher(omInfo* ominfo);
		void   setLocalIP(string localIP);
		void   setMaxRangeIP(unsigned int highestRangeIP);
		void   run();
		void   startSearch();
		bool   searchLocalNetworkForDaemons();
		bool   searchNodesFoundByOmdiscdForDaemons(omInfo* m_ominfo);
		bool   parseOmMapFileAndFillKnownGomdsMap();
		void   createKnownGomdMapEntry(string lineToBeParsed);
		string pingRemoteGomd(string IPAddress, int currentGomdPort);
		string saveKnownGomdsMapToFile();
		bool   loadKnownGomdsMapFromFile();
		void   appendNodeInfosToKnownGomdsMap(bool isOMEnabled);
		string getNodeIPbyNodeID(string nodeID);
		string getHostnameByIP(string ipToLookFor);
		string getIPByHostname(string hostName);
	};
#endif // end of __GOMD_GS_H
