/***************************************************************************
*                          llSupport.cpp  -  description
*                             -------------------
*    begin                : Sam Feb  1 17:08:52 CET 2003
*    copyright            : (C) 2003 by the gomd group at savannah.org/
*    email                : rpons@rinu.org, brian@axehind.com, jp80@libero.it, mosixview@t-online.de
****************************************************************************/

/**
 * NOTES:
 * Created by rejected
 *
 * Contains code to handle LoadLimit support
 */

#include "llSupport.h"

/**
 * default constructor for llSupport class
 */
llSupport::llSupport()
{
	m_isActive = isEnabled();
}
	
/**
 * checks if loadlimit feature is enabled on the local node
 * @return true if loadlimit is enabled on local node; false otherwise
 */
bool llSupport::isEnabled()
{
	if(m_util.readLineFromFile(LOADLIMIT_HPC_FILE) == UTILS_IO_ERROR)
	{
		return false;
	}
	return true;
}

/**
 * reads the file with the LoadLimit configuration and fills the LL map
 * @param llFile is the path to file file with the LL configuration.
 */
void llSupport::fillLLMap(string llFile)
{
	cout << "[LLS]: loading LL configuration from file..." << endl;
	cout << "[LLS]: opening file: \"" << llFile << "\""  << endl;
	m_llMap = new multimap<string,string>(m_util.parseSpecialFile(llFile,":"));
	if (m_llMap->size()==0)
	{
		cout  << "[LLS]: LoadLimit configuration file is empty!"  << endl;
		cout  << "[LLS]: LoadLimit support feature is disabled." << endl;
	}
	cout << "[LLS]: LL map succesfully filled." << endl;
}

/**
 * prints the contents of the ACL rules map
 */
void llSupport::printLLMap()
{
	m_util.printMultiMap(*m_llMap , "[LLS]: contents of LL map...", "       -> ");
}

/*void llSupport::setStatus(bool enableLoadLimit,  )
{
	if(enableLoadLimit==true)
	{
		
	}
	else
	{
	
	}	
}*/






