/***************************************************************************
*                          ncSocket.cpp  -  description
*                             -------------------
*    begin                : Sam Feb  1 17:08:52 CET 2003
*    copyright            : (C) 2003 by the gomd group at savannah.org/
*    email                : rpons@rinu.org, brian@axehind.com, jp80@libero.it, mosixview@t-online.de
****************************************************************************/

/**
 * NOTES:
 * Created by openMosixview
 * Last update by rejected
 *
 * this class implements a non blocking socket object (extends TCPSocket)
 */

 #include "ncSocket.h"

/**
 * Standard constructor (requires an valid IP and a port)
 * @param ia is a valid IP address
 * @param port is the port the serversocket is listening on
 * @param socketId identifies the instance ID of the socket
 */
ncSocket::ncSocket(InetAddress &ia,tpport_t port, int socketId): TCPSocket(ia, port)
{
	m_id = socketId;
}

/**
 * get client IP address (redefinition of onAccept() function of TCPSocket class)
 * @param ia is a reference to the InetAddress of the client
 * @param port is the client port
 * @return true (always ;) )
 */
bool ncSocket::onAccept(const InetHostAddress &ia, tpport_t port)
{
	in_addr ina;
	char *clientAddress;
	m_lastAcceptedClientIP.erase(); //clean up last client ip string

	try
	{
		//m_lastAcceptedClientIP.append(ia.getHostname()); //store lastly-accepted client ip
		ina = ia.getAddress();
		clientAddress = inet_ntoa(ina);
		m_lastAcceptedClientIP.append(clientAddress);
		if(m_lastAcceptedClientIP.size()==0 || m_lastAcceptedClientIP=="")
		{
			m_lastAcceptedClientIP="<ERROR>";
			return false;
		}
		cout << "[INF]: connection to " << m_lastAcceptedClientIP << " established." << endl;
		return true;
	}
	catch(Exception e)
	{
		return false;
	}
}

/**
 * Destructor for ncSocket class
 */
ncSocket::~ncSocket()
{
	//delete this;
}
