/***************************************************************************
*scxCheck.cpp-description
* -------------------
*begin: Sam Feb1 17:08:52 CET 2003
*copyright: (C) 2003 by the gomd group at savannah.org/
*email: rpons@rinu.org, brian@axehind.com, jp80@libero.it, mosixview@t-online.de
****************************************************************************/

/**
 * NOTES:
 * Last update by rejected
 *
 * Contains code to handle Access Control Lists check
 */

#include "scxCheck.h"

/**
 * constructor for class scxCheck
 * @param scxMap is a valid scxRulebook object filled with scxs
 * @param localIP contains the IP of local node
 */
scxCheck::scxCheck(multimap<string,string> scxMap, string localIP)
{
	m_scxMap = scxMap;
	m_localIP = localIP;
}

/**
 * used to invoke command checking and execution
 * @param toBeChecked is the command to be checked and, eventually, executed
 * @param clientStream is the pointer to an open socket (to the client)
 * @return an STL C++ list with the output of the command (if executed); an error
 *  message otherwise
 */
void scxCheck::tryToExecuteCommand(string toBeChecked, TCPStream* clientStream)
{
	list<string> cmdsList = m_util.parseCommand(toBeChecked);
	m_util.execCommandAndReturnChildOutput(cmdsList, clientStream); //we try to execute the program and get real-time output
}
