/***************************************************************************
*                          sysInfo.h  -  description
*                             -------------------
*    begin                : Sam Feb  1 17:08:52 CET 2003
*    copyright            : (C) 2003 by the gomd group at savannah.org/
*    email                : rpons@rinu.org, brian@axehind.com, jp80@libero.it, mosixview@t-online.de
****************************************************************************/


/**
 * NOTES:
 * Created by rejected
 * Last update by rejected
 *
 * Contains the code to get system infos
 */

#ifndef __GOMD_SYSINFO_H
	#define __GOMD_SYSINFO_H
	#include <glibtop.h>
	#include <glibtop/cpu.h>
	#include <glibtop/fsusage.h>
	#include <glibtop/loadavg.h>
	#include <glibtop/mem.h>
	#include <glibtop/mountlist.h>
	#include <glibtop/netload.h>
	#include <glibtop/proclist.h>
	#include <glibtop/procmem.h>
	#include <glibtop/procstate.h>
	#include <glibtop/procsignal.h>
	#include <glibtop/proctime.h>
	#include <glibtop/procuid.h>
	#include <glibtop/swap.h>
	#include <glibtop/uptime.h>

	#include <netinet/in.h>
	#include <arpa/inet.h>
	#include <inttypes.h>
	#include <stdlib.h>
	#include <cctype>
	#include <dirent.h>

	#include <cstring>
	#include <list>
	#include <map>

	#include "constants.h"
	#include "utils.h"

	#define SI_DEFAULT_INFOS_PER_CPU_IN_CPUINFO	17
	#define SI_MAX_BUFFER_SIZE			2000

	using namespace std;

	class sysInfo
	{
		public:
		utils m_util;

		public:
		string		getCpuinfoFile(string lineStart="", bool printBanner=true);
		string 		getMeminfoFile(string lineStart, bool printBanner=true);
		int		getCpusNumber();
		string		getUptime();
		string		getPidList(list<int>* pidList=NULL);


		string		getCpusLoad();
		string 		getNetLoad(const char *iface);

		const char* 	networkFlagToString(unsigned long netFlags);
		string 		getMountList(string lineStart, bool printBanner=true);
		string 		getMountUsageList(string lineStart, bool printBanner=true);

		string		getSwapUsage();
		string 		getLoadAverage();
		string		getProcState(long pid);
		string		getProcUIDAndTTY(long pid);
		string		getProcMemory(long pid);
		string		getProcTime(long pid);
		string		getProcSignal(long pid);
	};

#endif // __GOMD_SYSINFO_H
