/***************************************************************************
*                          sysLog.cpp  -  description
*                             -------------------
*    begin                : Sam Feb  1 17:08:52 CET 2003
*    copyright            : (C) 2003 by the gomd group at savannah.org/
*    email                : rpons@rinu.org, brian@axehind.com, jp80@libero.it, mosixview@t-online.de
****************************************************************************/


/**
 * NOTES:
 * Created by rejected
 * Last update by rejected
 *
 * Contains the code to write to system log
 */
 
#include "sysLog.h"

/**
 * default constructor
 */
sysLog::sysLog()
{
	m_whatToDo = DO_ALL;
}

/**
 * constructor
 */
sysLog::sysLog(int whatToDo)
{
	m_whatToDo = whatToDo;
}

/**
 * set the operation to do
 * @param whatToDo is the code of the operation to do
 */
void sysLog::setOperationsToDo(int whatToDo)
{
	m_whatToDo = whatToDo;
}

/**
 * get the operation to do
 * @return the operation to do
 */
int sysLog::getWhatToDo()
{
	return m_whatToDo;
}

/**
 * log a string into the system logger
 * @param level is the level of message to be logged
 * @param toBeLOgged is the string to write into the system logger
 */
void  sysLog::log(int level, string toBeLogged)
{
	if(m_whatToDo==DO_ALL || m_whatToDo==LOG_ONLY)
	{
		//cout << "here #1" << endl;
		syslog(level, toBeLogged.c_str());
	}

	if(m_whatToDo==DO_ALL || m_whatToDo==PRINT_ONLY)
	{
		//cout << "here #2" << endl;
		cout << toBeLogged << endl;
	}
}

/**
 * log a C string into the system logger
 * @param level is the level of message to be logged
 * @param toBeLOgged is the C string to write into the system logger
 */
void  sysLog::log(int level, const char* toBeLogged)
{
	string input;
	input.append(toBeLogged);
	log(level,input);
}

/**
 * prints the available levels
 */
void  sysLog::printLevelsForLog()
{
	cout << "Available Levels" << endl;
	cout << "----------------" << endl;
	cout << "LOG_EMERG   ->  action must be taken immediately" << endl;
	cout << "LOG_ALERT   ->  action must be taken immediately" << endl;
	cout << "LOG_CRIT    ->  critical conditions" << endl;
	cout << "LOG_ERR     ->  error conditions" << endl;
	cout << "LOG_WARNING ->  warning conditions" << endl;
	cout << "LOG_NOTICE  ->  normal, but significant, condition" << endl;
	cout << "LOG_INFO    ->  informational message" << endl;
	cout << "LOG_DEBUG   ->  debug-level message" << endl;
}
