/***************************************************************************
*                          utils.h  -  description
*                             -------------------
*    begin                : Sam Feb  1 17:08:52 CET 2003
*    copyright            : (C) 2003 by the gomd group at savannah.org/
*    email                : rpons@rinu.org, brian@axehind.com, jp80@libero.it, mosixview@t-online.de
****************************************************************************/


/**
 * NOTES:
 * Created by rejected
 * Last update by rejected
 *
 * Contains the some useful functions used in the whole project
 */

#ifndef __GOMD_UTILS_H
	#define __GOMD_UTILS_H

	#include <cc++/misc.h>
	#include <cc++/socket.h>
	#include <algorithm>
	#include <cstdio>
	#include <cerrno>
	#include <cstdlib>
	#include <cstring>
	#include <iostream>
	#include <fstream>
	#include <cstring>
	#include <string>
	#include <cassert>
	#include <map>
	#include <list>
	#include <sys/time.h>
	#include <sys/types.h>
	#include <sys/wait.h>
	#include "constants.h"

	using namespace std;
	using namespace ost;

	class utils
	{
		//vars
		private:
		ofstream* m_outputFile;

		//functions
		public:
		//string functions (conversions,..)
		int stringToInt(string str);
		int stringToInt(const char* str);
		long stringToLong(const char* str);
		long stringToLong(string str);
		string intToString(const int i);
		string doubleToString(const double i);
		string longToString(const long i);
		void ucase(string& toBeConverted);
		void lcase(string& toBeConverted);
		void initStringArray(string array[], int len);
		void trim(string& toBeTrimmed);
		bool containsLetters(string toBeTested);
		string boolToColorString(bool value);

		//file operations functions
		multimap<string,string> parseSpecialFile(string inputFile, string strSeparator, int skipLines=0);
		string readLineFromFile(string inputFile);
		string readFile(string inputFile, string lineStart="", string lineEnd="");
		list<string> readFileEx(string inputFile, string lineStart="", string lineEnd="");
		list<string> searchSubstringInFile(string inputFile, string toSearch);
		unsigned int getSubStringOccurInFile(string inputFile, string toSearch);
		bool writeToFile(string outputFile, string valueToWrite);
		bool writeToFile(string outputFile, int valueToWrite);
		void openFile(string outputFile, bool append);
		bool writeToOpenFile(string valueToWrite);
		bool closeFile();

		//network helper functions
		string getSubnetFromIP(string ipToParse);
		string getHostNumberFromIP(string ipToParse);

		//unix operations functions
		list<string> parseCommand(string toBeParsed);
		list<string> execCommandAndReturnChildOutput(list<string> cmdList, TCPStream* clientStream);
		string getFilenamePointedByLink(string linkFilePath);

		//linked list management
		void printLinkedList(list<string> ll, string prompt, string lineStart);
		void printMultiMap(multimap<string,string> mm, string prompt, string lineStart);
		void cloneStringLinkedLists(list<string>& sourceLL, list<string>& destinationLL);

		//time function
		string getLocalTime();
	};
#endif // end of __GOMD_UTILS_H
