/***************************************************************************
*                          xmlLog.cpp  -  description
*                             -------------------
*    begin                : Sam Feb  1 17:08:52 CET 2003
*    copyright            : (C) 2003 by the gomd group at savannah.org/
*    email                : rpons@rinu.org, brian@axehind.com, jp80@libero.it, mosixview@t-online.de
****************************************************************************/


/**
 * NOTES:
 * Created by rejected
 * Last update by rejected
 *
 * Contains the code to write to log on a XML file
 */

#include "xmlLog.h"

/**
 * log a C string into the system logger
 * @param level is the level of message to be logged
 * @param toBeLOgged is the C string to write into the system logger
 */
void  xmlLog::appendToLog(string level, string description)
{
	string input;
	input += "<logbook>";
	input += "<entry>";
	input += "<level>" + level + "</level>";
	input += "<description>" + description + "</description>";
	input += "<time>" + m_util.getLocalTime() + "</time>";
	input += "</entry>";
	input += "</logbook>";

	m_util.openFile(XML_LOG_FILE, true);
	if (m_util.writeToOpenFile(input)==true)
	{
		m_util.closeFile();
	}
}

/**
 * prints the available levels
 */
void  xmlLog::printLevelsForLog()
{
	cout << "Available Levels" << endl;
	cout << "----------------" << endl;
	cout << "LOG_EMERG   ->  action must be taken immediately" << endl;
	cout << "LOG_ALERT   ->  action must be taken immediately" << endl;
	cout << "LOG_CRIT    ->  critical conditions" << endl;
	cout << "LOG_ERR     ->  error conditions" << endl;
	cout << "LOG_WARNING ->  warning conditions" << endl;
	cout << "LOG_NOTICE  ->  normal, but significant, condition" << endl;
	cout << "LOG_INFO    ->  informational message" << endl;
	cout << "LOG_DEBUG   ->  debug-level message" << endl;
}
